﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Security.Cryptography

' This will not work very well for payload sizes over 16 bits (> 65536)
Module Module1

    Sub Main()
        Dim server As TcpListener
        server = Nothing
        Try
            ' Set the TcpListener on port 13000.
            Dim port As Int32 = 13000
            ' Listen on all interfaces.
            Dim localAddr As IPAddress = IPAddress.Parse("0.0.0.0")

            server = New TcpListener(localAddr, port)

            ' Start listening for client requests.
            server.Start()

            ' Buffer for reading data
            Dim bytes(8 + 65536) As Byte
            Dim data As String = Nothing

            ' Enter the listening loop.
            While True
                Console.Write("Waiting for a connection... ")

                ' Perform a blocking call to accept requests.
                ' You could also user server.AcceptSocket() here.
                Dim client As TcpClient = server.AcceptTcpClient()
                Console.WriteLine("Connected!")

                data = Nothing

                ' Get a stream object for reading and writing
                Dim stream As NetworkStream = client.GetStream()

                Dim i As Int32
                Dim k As Int32

                ' parse the headers
                k = stream.Read(bytes, 0, bytes.Length)
                ' bytes should contain the header info
                ' parse it here, it'll look something like this:
                '
                'GET /chat HTTP/1.1
                'Host: server.example.com
                'Upgrade: websocket
                'Connection: Upgrade
                'Sec-WebSocket-Key: dGhlIHNhbXBsZSBub25jZQ==
                'Origin: http://example.com
                'Sec-WebSocket-Protocol: chat, superchat
                'Sec-WebSocket-Version: 13
                Dim rawheaders As String = System.Text.Encoding.ASCII.GetString(bytes, 0, k - 9)
                rawheaders = rawheaders.Replace(Chr(13), "").Trim()  ' kill the CRs
                Dim headers As String() = rawheaders.Split(New Char() {Chr(10)})  ' split on the LFs

                Dim sec As String = ""

                ' get the header information
                For i = 0 To headers.Length - 1
                    Dim j = headers(i).IndexOf(":")
                    If j = -1 Then Continue For
                    Dim header_line As String() = {Left(headers(i), j), Right(headers(i), headers(i).Length - j - 2)}
                    If header_line(0).ToLower() = "sec-websocket-key" Then
                        sec = header_line(1)
                    End If
                Next

                ' The handshake is constructed by concatenating key and a
                ' GUID, the taking the SHA1 hash of both and responding with
                ' a base64 encoded version.

                sec += "258EAFA5-E914-47DA-95CA-C5AB0DC85B11"

                ' build the bytes run through SHA1
                Dim secbytes As Byte() = System.Text.Encoding.ASCII.GetBytes(sec)
                Dim sha1 As SHA1 = New SHA1CryptoServiceProvider()
                Dim hashbytes As Byte() = sha1.ComputeHash(secbytes)
                Dim hash As String = Convert.ToBase64String(hashbytes)

                ' and respond
                '
                'HTTP/1.1 101 Switching Protocols
                'Upgrade: websocket
                'Connection: Upgrade
                'Sec-WebSocket-Accept: (SHA1 Hash)

                Dim respbytes As Byte() = System.Text.Encoding.ASCII.GetBytes( _
                    "HTTP/1.1 101 Switching Protocols" & vbCrLf & _
                    "Upgrade: websocket" & vbCrLf & _
                    "Connection: Upgrade" & vbCrLf & _
                    "Sec-WebSocket-Accept: " & hash & vbCrLf & vbCrLf)

                stream.Write(respbytes, 0, respbytes.Length)

                ' Now we can get down to business.

                ' Loop to receive all the data sent by the client.
                i = stream.Read(bytes, 0, bytes.Length)
                While (i <> 0)
                    ' decode the frame
                    bytes(1) = bytes(1) And 127  ' remove the mask bit
                    Dim paylen As ULong = bytes(1)
                    Dim loc As Integer = 2
                    If paylen = 126 Then
                        Dim lenbuf(1) As Byte
                        Array.Copy(bytes, loc, lenbuf, 0, 2)
                        Array.Reverse(lenbuf)  ' convert to little endian
                        paylen = BitConverter.ToUInt16(lenbuf, 0)
                        loc += 2
                    ElseIf paylen = 127 Then
                        Dim lenbuf(7) As Byte
                        Array.Copy(bytes, loc, lenbuf, 0, 8)
                        Array.Reverse(lenbuf)  ' convert to little endian
                        paylen = BitConverter.ToUInt64(lenbuf, 0)
                        loc += 8
                    End If
                    ' client to server should ALWAYS be masked, so assume
                    Dim mask(4) As Byte
                    Array.Copy(bytes, loc, mask, 0, 4)
                    ' unmask the payload and store it in bytes for transmission
                    For j = 0 To paylen - 1
                        bytes(loc + j) = bytes(loc + 4 + j) Xor mask(j Mod 4)
                    Next

                    ' get the data and notify
                    data = System.Text.Encoding.UTF8.GetString(bytes, loc, paylen)
                    Console.WriteLine("Received: {0}", data)

                    ' Send back a response.
                    stream.Write(bytes, 0, loc + paylen)
                    Console.WriteLine("Sent: {0}", data)

                    i = stream.Read(bytes, 0, bytes.Length)

                End While

                ' Shutdown and end connection
                client.Close()
            End While
        Catch e As SocketException
            Console.WriteLine("SocketException: {0}", e)
        Finally
            server.Stop()
        End Try

        Console.WriteLine(ControlChars.Cr + "Hit enter to continue....")
        Console.Read()
    End Sub

End Module
